	device zxspectrum128

	macro	sectors datab,datae

 IF low (datae-datab)=0
   db high (datae-datab)
 ELSE
   db (1+high (datae-datab))
 ENDIF

	endm

	org $8000-14*2-9
scl_b:
;header_b:
 db "SINCLAIR"
 db 2; 

;-1st
;    12345678t
 db "hip15b  C"
 dw 22592;  
 dw end-begin;
 sectors begin,end; 

;-2nd
;    12345678t
 db "hip     B"
 dw basic_e-basic_b-4;start
 dw basic_e-basic_b-4;length?
 sectors basic_b,basic_e;db 1;sectors
;header_e:

 align 256;        ORG #8000
begin
 incbin "hip.bin"
end

;28672

 align 256; org $8400
basic_b:
 db #00,10; 
 DW EndLine1 - Line1
Line1:

 db $FD;clear
 db $B0;val
 db $22,"28671",$22,":"
 db $F9;randomize
 db $C0;usr
 db $B0;val
 db $22,"15619",$22,":"
 db $EA;rem
 db ":"
 db $EF;load
 db $22,"hip15b",$22
 db $AF;code
 db #0D
EndLine1:

 db #00,20; 
 DW EndLine2 - Line2
Line2:
 db $F9;randomize
 db $C0;usr
 db $B0;val
 db $22,"22592",$22
 db #0D
EndLine2:

 db #80;for autorun
 db #AA,10,0
basic_e:

 align 256; org $8500

scl_e:

	savebin "test.scl",scl_b,scl_e-scl_b

	LUA

	local fp
	local checksum
	
	fp = assert(io.open("test.scl", "rb"))
	checksum=0
	while true do
		local byte = fp:read(1)
		if byte==nil then
			break
		end
		checksum=checksum+string.byte(byte)
	end
	assert(fp:close())
	print("writing",string.format("%08X",checksum))
	fp = assert(io.open("test.scl", "a"))

	for i=1,4 do
    	fp:write(string.char(checksum%256))
    	checksum=math.floor(checksum/256)
    end

--	assert(fp:flush())
	assert(fp:close())
	ENDLUA


